include(unixas.h)

	TITLE({karrtn - fortran character primitives {02-feb-82}})

	
	SUBTITLE({integer function  karasc (char)})
#     INTEGER FUNCTION  KARASC (CHAR)
#     BYTE CHAR(4)
#     KARASC = CHAR(1)
#     IF (CHAR(1) .LT. 0) KARASC = -1
#     RETURN
#     END

	PROC(karasc,,{{char}})
	cvtbl	*char,r0
	bgeq	ascdon			# jump if byte > 0
	mnegl	$1,r0			# else return -1 for non-ascii character
ascdon: ret


	SUBTITLE({integer function  karchr (ord)})
#     INTEGER FUNCTION  KARCHR (ORD)
#     INTEGER MASK
#     BYTE CHAR(4),ORD(4)
#     EQUIVALENCE (MASK,CHAR(1))
#     DATA MASK/'    '/
#     CHAR(1) = ORD(1)
#     KARCHR = MASK
#     RETURN
#     END

	PROC(karchr,,{{ord}})
	movl	blanks,r0
	movb	*ord,r0
	ret

	.data
blanks: .byte	32,32,32,32		# fullword blank string


	SUBTITLE({integer function  karcm2 (texta,loca,textb,locb,length)})
#     INTEGER FUNCTION KARCM2 (TEXTA,LOCA,TEXTB,LOCB,LENGTH)
#     (Compare Characters)
#     Given   two  packed  character  strings,  TEXTB(*)  and  TEXTA(*),
#     starting at character position "LOCB"  in  TEXTB(*)  and  position

#     "LOCA"   in  TEXTA(*), compare "LENGTH" characters in TEXTB(*) and
#     TEXTA(*).  Return a function value of KARCMP = -1 (A < B), 0 (A  =
#     B), or +1 (A > B) in the ASCII collating sequence.  Upper-case and
#     lower-case are treated as equivalent.
#     (20-FEB-80)

	PROC(karcm2,ALL,{{texta},{loca},{textb},{locb},{length}})

	tstl    *length			# length <= 0?
	bleq	cm2eql			# yes, quit immediately.
	tstl	*loca			# loca <= 0?
	bleq	cm2eql			# yes, quit immediately.
	tstl	*locb			# locb <= 0?
	bleq	cm2eql			# yes, quit immediately.

	addl3	texta,*loca,r6		# addr(texta(1+loca))
	addl3	textb,*locb,r7		# addr(textb(1+locb))
	movl	$1,r5

cm2loop:
	movb	-2(r6)[r5],r10
	cmpb	$97,r10
	bgtr	cm2l1
	cmpb	$122,r10
	blss	cm2l1
	subb2	$32,r10
cm2l1:  movb	-2(r7)[r5],r11
	cmpb	$97,r11
	bgtr	cm2l2
	cmpb	$122,r11
	blss	cm2l2

	subb2	$32,r11
cm2l2:  cmpb	r10,r11
	blss	cm2lss
	bgtr	cm2gtr
	acbl	*length,$1,r5,cm2loop

cm2eql: clrl	r0
	ret

cm2gtr: movl	$1,r0
	ret

cm2lss: mnegl	$1,r0
	ret


	SUBTITLE({integer function  karcmp (texta,loca,textb,locb,length)})
#     INTEGER FUNCTION KARCMP (TEXTA,LOCA,TEXTB,LOCB,LENGTH)
#     (Compare Characters)
#     Given   two  packed  character  strings,  TEXTB(*)  and  TEXTA(*),
#     starting at character position "LOCB"  in  TEXTB(*)  and  position
#     "LOCA"  in   TEXTA(*), compare "LENGTH" characters in TEXTB(*) and
#     TEXTA(*).  Return a function value of KARCMP = -1 (A < B), 0 (A  =
#     B), or +1 (A > B) in the ASCII collating sequence.
#     (20-FEB-80)

	PROC(karcmp,{2,3,4,5,6,7},{{texta},{loca},{textb},{locb},{length}})

	tstl	*length			# length <= 0?
	bleq	cmpeql			# yes, quit immediately.
	tstl	*loca			# loca <= 0?
	bleq	cmpeql			# yes, quit immediately.
	tstl	*locb			# locb <= 0?
	bleq	cmpeql			# yes, quit immediately.

	addl3	texta,*loca,r6		# addr(texta(1+loca))
	addl3	textb,*locb,r7		# addr(textb(1+locb))
#
# Use autodecrement mode to get addr(textb(locb)) and
# addr(texta(loca)).
#
	cmpc3	*length,-(r6),-(r7)
	blss	cmplss
	beql	cmpeql
cmpgtr: movl	$1,r0
	ret
cmplss: mnegl	$1,r0
	ret
cmpeql: clrl	r0
	ret


	SUBTITLE({subroutine  karget (char,string,npos)})
#     SUBROUTINE  KARGET (CHAR,STRING,NPOS)
#     INTEGER NPOS
#     BYTE CHAR(4),STRING(NPOS)
#     CHAR(1) = 0
#     CHAR(2) = ' '
#     CHAR(3) = ' '
#     CHAR(4) = ' '
#     IF (NPOS .GT. 0) CHAR(1) = STRING(NPOS)
#     RETURN
#     END

	PROC(karget,,{{char},{string},{npos}})
	tstl	*npos			# npos <= 0?
	bleq	geterr			# yes, quit immediately.

	addl3	string,*npos,r1		# addr(string(npos+1))
	movl	blanks,*char		# supply padding blanks
	movb	-(r1),*char
getdon: ret

geterr:	clrl	*char			# char = 0 if npos illegal
	ret


	SUBTITLE({integer function  karid2 (string,locstr,lenstr,substring,locsub,lensub)})
	PROC(karid2,ALL,{{string},{locstr},{lenstr},{substring},{locsub},{lensub}})
	tstl	*locstr			# check arguments >= 0
	bleq	id2zero
	tstl	*lenstr
	bleq	id2zero
	tstl	*locsub			# check arguments >= 0
	bleq	id2zero
	tstl	*lensub
	bleq	id2zero

	addl3	*locstr,string,r6	# a(string(locstr+1))
	addl3	*locsub,substring,r7	# a(substring(locsub+1))
	decl	r6			# a(string(locstr))	
	decl	r7			# a(substring(locsub))
	movl	r7,r4			# a(substring(locsub))
	subl3	*lensub,*lenstr,r11	# lenstr-lensub = outer loop count
	blss	id2zero			# done if count negative
	movl	*lensub,r3		# inner loop count
	movl	*locstr,r0
	decl	r0			# tentative function value = locstr-1

i1loop:	incl	r0			# increment function value
	movl	r3,r10			# inner loop count
	movl	r6,r5			# save current pointer

i2loop:	movzbl	(r6)+,r1		# get byte and increment pointer
	movzbl	(r4)+,r2		# get byte and increment pointer
	cmpb	touctb[r1],touctb[r2]	# same bytes?
	bneq	i2test			# no
	sobgtr	r10,i2loop		# loop lensub times
	ret				# match, index in r0

i2test:	movl	r7,r4			# restore substring pointer
	movl	r5,r6			# restore string pointer
	incl	r6			# point to next string byte
	sobgeq	r11,i1loop		# loop lenstr+1-lensub times

id2zero:clrl	r0			# karid2 = 0 if we fell through
	ret

	.data
touctb:					# default translation table (00..ff)

# bytes 0..96 into themselves

	.byte	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9
	.byte	 10, 11, 12, 13, 14, 15, 16, 17, 18, 19
	.byte	 20, 21, 22, 23, 24, 25, 26, 27, 28, 29
	.byte	 30, 31, 32, 33, 34, 35, 36, 37, 38, 39
	.byte	 40, 41, 42, 43, 44, 45, 46, 47, 48, 49
	.byte	 50, 51, 52, 53, 54, 55, 56, 57, 58, 59
	.byte	 60, 61, 62, 63, 64, 65, 66, 67, 68, 69
	.byte	 70, 71, 72, 73, 74, 75, 76, 77, 78, 79
	.byte	 80, 81, 82, 83, 84, 85, 86, 87, 88, 89
	.byte	 90, 91, 92, 93, 94, 95, 96 

# lower case 97..122 to upper case 65..90

	.byte			    65, 66, 67, 68, 69	
	.byte	 70, 71, 72, 73, 74, 75, 76, 77, 78, 79
	.byte	 80, 81, 82, 83, 84, 85, 86, 87, 88, 89
	.byte	 90

# remaining bytes 123..255 into themselves

	.byte		    123,124,125,126,127,128,129
	.byte	130,131,132,133,134,135,136,137,138,139
	.byte	140,141,142,143,144,145,146,147,148,149
	.byte	150,151,152,153,154,155,156,157,158,159
	.byte	160,161,162,163,164,165,166,167,168,169
	.byte	170,171,172,173,174,175,176,177,178,179
	.byte	180,181,182,183,184,185,186,187,188,189
	.byte	190,191,192,193,194,195,196,197,198,199
	.byte	200,201,202,203,204,205,206,207,208,209
	.byte	210,211,212,213,214,215,216,217,218,219
	.byte	220,221,222,223,224,225,226,227,228,229
	.byte	230,231,232,233,234,235,236,237,238,239
	.byte	240,241,242,243,244,245,246,247,248,249
	.byte	250,251,252,253,254,255


	SUBTITLE({integer function  karidx (string,locstr,lenstr,substring,locsub,lensub)})
	PROC(karidx,ALL,{{string},{locstr},{lenstr},{substring},{locsub},{lensub}})
	tstl	*locstr			# check arguments >= 0
	bleq	idxzero
	tstl	*lenstr
	bleq	idxzero
	tstl	*locsub			# check arguments >= 0
	bleq	idxzero
	tstl	*lensub
	bleq	idxzero

	addl3	*locstr,string,r6	# a(string(locstr+1))
	addl3	*locsub,substring,r7	# a(substr(locsub+1))
	matchc	*lensub,-(r7),*lenstr,-(r6)
	bneq	idxzero			# return 0 if no match
	subl3	string,r3,r0		# r3 = a(last match byte + 1)
	subl2	*lensub,r0
	incl	r0			# karidx=1+(r3)-a(string)-lensub

	ret

idxzero:
	clrl	r0			# karidx = 0 if not found
	ret


	SUBTITLE({integer function  karlc (char)})
#     INTEGER FUNCTION  KARLC (CHAR)
#     BYTE MASK(4)
#     INTEGER CHAR,IMASK
#     EQUIVALENCE (MASK,IMASK)
#     IMASK = CHAR
#     IF ((MASK(1) .GE. 65) .AND. (MASK(1) .LE. 90))
#    X	   MASK(1) = MASK(1) + 32
#     KARLC = IMASK
#     RETURN
#     END

	PROC(karlc,,{{char}})
	movl	*char,r0
	cmpb	$65,r0
	bgtr	lcdon
	cmpb	$90,r0
	blss	lcdon
	addb2	$32,r0
lcdon:  ret


	SUBTITLE({integer function  karlcl (ord)})
#     INTEGER FUNCTION  KARLCL (ORD)
#     INTEGER MASK
#     BYTE CHAR(4),ORD(4)
#     EQUIVALENCE (MASK,CHAR(1))
#     DATA MASK/'    '/
#     CHAR(1) = ORD(1)
#     KARLCL = MASK
#     RETURN
#     END

	PROC(karlcl,,{{ord}})
	movl	blanks,r0
	movb	*ord,r0
	ret


	SUBTITLE({subroutine  karmov (target,loct,source,locs,length)})
#	SUBROUTINE KARMOV (TARGET,LOCT,SOURCE,LOCS,LENGTH)
#     (Move Characters)
#     Given two  packed  character  strings,  SOURCE(*)  and  TARGET(*),
#     starting  at  character  position "LOCS" in SOURCE(*) and position
#     "LOCT" in TARGET(*), move "LENGTH" characters  from  SOURCE(*)  to
#     TARGET(*).
#     (20-FEB-80)

	PROC(karmov,{2,3,4,5,6,7},{{target},{loct},{source},{locs},{length}})

	tstl	*length			# length <= 0?
	bleq	movdon			# yes, quit immediately.
	tstl	*loct			# loct <= 0?
	bleq	movdon			# yes, quit immediately.
	tstl	*locs			# locs <= 0?
	bleq	movdon			# yes, quit immediately.

	addl3	source,*locs,r7		# addr(source(1+locs))
	addl3	target,*loct,r6		# addr(target(1+loct))
	cmpl	r6,r7			# target before source in memory?
	blequ	movqck			# yes, do quick move
	addl3	r7,*length,r1		# get address(source(locs+length))
	cmpl	r1,r6			# target begins inside source in memory?
	blssu	movqck			# no, do quick move

	movl	$1,r1			# loop index

movloop:				# copy loop when target inside source
	movb	-2(r7)[r1],-2(r6)[r1]
	acbl	*length,$1,r1,movloop

	ret
#
# Use autodecrement mode to get addr(source(locs)) and
# addr(target(loct)).
#
movqck: movc3	*length,-(r7),-(r6)
movdon: ret


	SUBTITLE({integer function  karord (char)})
#     INTEGER FUNCTION  KARORD (CHAR)
#     BYTE CHAR(4)
#     KARORD = CHAR(1)
#     IF (CHAR(1) .LT. 0) KARORD = 256 + KARORD
#     RETURN
#     END

	PROC(karord,,{{char}})
	movzbl	*char,r0
	ret


	SUBTITLE({subroutine  karpak (target,loctar,source,lensrc)})
#     SUBROUTINE  KARPAK (TARGET,LOCTAR,SOURCE,LENSRC)
#     INTEGER LENSRC,LOCTAR,IT,IS,I
#     BYTE TARGET(1),SOURCE(LENSRC)
#     IF (LENSRC .LE. 0) GO TO 20
#     IT = LOCTAR
#     IS = 1
#	   DO 10 I = 1,LENSRC
#	   TARGET(IT) = SOURCE(IS)
#	   IS = IS + 4
#	   IT = IT + 1
#  10	   CONTINUE
#  20 RETURN
#     END

	PROC(karpak,ALL,{{target},{loctar},{source},{lensrc}})
	tstl	*lensrc			# lensrc <= 0?
	bleq	pakdon			# yes, quit immediately.
	tstl	*loctar			# loctar <= 0?
	bleq	pakdon			# yes, quit immediately.

	movl	source,r7		# a(source(1))
	addl3	target,*loctar,r6	# a(target(loctar+1))
	movl	$1,r10			# loop index

pakloop:
	cvtlb	-4(r7)[r10],-2(r6)[r10]	# copy top byte
	acbl	*lensrc,$1,r10,pakloop

pakdon: ret


	SUBTITLE({subroutine  karput (char,string,npos)})
#     SUBROUTINE  KARPUT (CHAR,STRING,NPOS)
#     INTEGER NPOS
#     BYTE CHAR(4),STRING(NPOS)
#     IF (NPOS .GT. 0) STRING(NPOS) = CHAR(1)
#     RETURN
#     END

	PROC(karput,,{{char},{string},{npos}})
	tstl	*npos			# npos <= 0?
	bleq	putdon			# yes, quit immediately.

	addl3	string,*npos,r1		# addr(string(npos+1))
	movb	*char,-(r1)
putdon: ret


	SUBTITLE({subroutine  karswp (texta,loca,textb,locb,length)})
	PROC(karswp,ALL,{{texta},{loca},{textb},{locb},{length}})
	tstl	*loca			# check arguments
	bleq	swpdon
	tstl	*locb
	bleq	swpdon
	tstl	*length
	bleq	swpdon

	addl3	texta,*loca,r6		# a(texta(loca+1))
	addl3	textb,*locb,r7		# a(textb(locb+1))
	movl	$1,r10			# loop index

swploop:
	movb	-2(r6)[r10],r0		# get byte from texta
	movb	-2(r7)[r10],r1		# get byte from textb
	movb	r1,-2(r6)[r10]		# put b byte in a
	movb	r0,-2(r7)[r10]		# put a byte in b
	acbl	*length,$1,r10,swploop	# loop length times

swpdon:	ret


	SUBTITLE({integer function  karuc (char)})
#     INTEGER FUNCTION  KARUC (CHAR)
#     BYTE MASK(4)
#     INTEGER CHAR,IMASK
#     EQUIVALENCE (MASK,IMASK)
#     IMASK = CHAR
#     IF ((MASK(1) .GE. 97) .AND. (MASK(1) .LE. 122))
#    X	   MASK(1) = MASK(1) - 32
#     KARUC = IMASK
#     RETURN
#     END

	PROC(karuc,,{{char}})
	movl	*char,r0
	cmpb	$97,r0
	bgtr	ucdon
	cmpb	$122,r0
	blss	ucdon
	subb2	$32,r0
ucdon:  ret


	SUBTITLE({subroutine  karupk (target,source,locsrc,lensrc)})
#     SUBROUTINE  KARUPK (TARGET,SOURCE,LOCSRC,LENSRC)
#     INTEGER LENSRC,LOCTAR,IT,IS,I
#     BYTE TARGET(1),SOURCE(1)
#     IF (LENSRC .LE. 0) GO TO 20
#     IT = 1
#     IS = LOCSRC
#	   DO 10 I = 1,LENSRC
#	   TARGET(IT) = SOURCE(IS)
#	   IS = IS + 1
#	   IT = IT + 4
#  10	   CONTINUE
#  20 RETURN
#     END

	PROC(karupk,ALL,{{target},{source},{locsrc},{lensrc}})
	tstl	*lensrc			# lensrc <= 0?
	bleq	upkdon			# yes, quit immediately.
	tstl	*locsrc			# locsrc <= 0?
	bleq	upkdon			# yes, quit immediately.

	movl	target,r6		# a(target(1))
	addl3	source,*locsrc,r7	# a(source(locsrc+1))
	movl	$1,r10			# loop index
	movl	blanks,r0		# padding word

upkloop:
	movb	-2(r7)[r10],r0		# deposit byte in '[sp]<sp><sp><sp>'
	movl	r0,-4(r6)[r10]		# store '[byte]<sp><sp><sp>' in target
	acbl	*lensrc,$1,r10,upkloop

upkdon: ret


	SUBTITLE({subroutine  karvfy (text,loct,lent,patern,locp,lenp)})
	PROC(karvfy,ALL,{{text},{loct},{lent},{patern},{locp},{lenp}})
	tstl	*loct			# check argument validity
	bleq	vfyzero
	tstl	*lent
	bleq	vfyzero
	tstl	*locp
	bleq	vfyzero
	tstl	*lenp
	bleq	vfyzero
#
# Arguments are ok.  Build a lookup table on the  stack  for  the  spanc
# instruction.
#
	subl2	$256,sp			# bump sp down 256 bytes to point to table
	movc3	$256,defvft,(sp)	# move default table to stack
	addl3	patern,*locp,r6		# a(patern(locp+1))
	movl	$1,r10			# loop index

bldvftloop:
	movzbl	-2(r6)[r10],r11		# get patern byte
	movb	r11,(sp)[r11]		# put byte in table
	acbl	*lenp,$1,r10,bldvftloop	# loop lenp times

	addl3	text,*loct,r6		# a(text(loct+1))
	spanc	*lent,-1(r6),(sp),$255
	beql	vfyzero			# all characters found
	subl3	text,r1,r0
	incl	r0			# karvfy=(r1)-a(text)+1

vfydon:	ret

vfyzero:	
	clrl	r0			# karvfy = 0 if bad args or failed search
	ret

	.data
defvft:					# default translation table (all zero)
	.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0


	SUBTITLE({subroutine  karxlt (text,loct,lent,old,loco,new,locn,lenn)})
	PROC(karxlt,ALL,{{text},{loct},{lent},{old},{loco},{new},{locn},{lenn}})
	tstl	*loct			# check argument validity
	bleq	xltdon
	tstl	*lent
	bleq	xltdon
	tstl	*loco
	bleq	xltdon
	tstl	*locn
	bleq	xltdon
	tstl	*lenn
	bleq	xltdon
#
# Arguments   are  ok.   Copy  the  translate table onto the stack, then
# replace characters from old with those from new.
#
	subl2	$256,sp			# bump sp down 256 bytes to point to table
	movc3	$256,defxtb,(sp)	# move default table to stack
	addl3	old,*loco,r6		# a(old(loco+1))
	addl3	new,*locn,r7		# a(new(locn+1))
	movl	$1,r10			# loop index

bldxltloop:
	movzbl	-2(r6)[r10],r11		# get old byte
	movb	-2(r7)[r10],(sp)[r11]	# put new byte in table at old byte loc
	acbl	*lenn,$1,r10,bldxltloop	# loop lenn times

	addl3	text,*loct,r6		# a(text(loct+1))
	movtc	*lent,-1(r6),$0,(sp),*lent,-1(r6)

xltdon:	ret

	.data
defxtb:					# default translation table (00..ff)
	.byte	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9
	.byte	 10, 11, 12, 13, 14, 15, 16, 17, 18, 19
	.byte	 20, 21, 22, 23, 24, 25, 26, 27, 28, 29
	.byte	 30, 31, 32, 33, 34, 35, 36, 37, 38, 39
	.byte	 40, 41, 42, 43, 44, 45, 46, 47, 48, 49
	.byte	 50, 51, 52, 53, 54, 55, 56, 57, 58, 59
	.byte	 60, 61, 62, 63, 64, 65, 66, 67, 68, 69
	.byte	 70, 71, 72, 73, 74, 75, 76, 77, 78, 79
	.byte	 80, 81, 82, 83, 84, 85, 86, 87, 88, 89
	.byte	 90, 91, 92, 93, 94, 95, 96, 97, 98, 99
	.byte	100,101,102,103,104,105,106,107,108,109
	.byte	110,111,112,113,114,115,116,117,118,119
	.byte	120,121,122,123,124,125,126,127,128,129
	.byte	130,131,132,133,134,135,136,137,138,139
	.byte	140,141,142,143,144,145,146,147,148,149
	.byte	150,151,152,153,154,155,156,157,158,159
	.byte	160,161,162,163,164,165,166,167,168,169
	.byte	170,171,172,173,174,175,176,177,178,179
	.byte	180,181,182,183,184,185,186,187,188,189
	.byte	190,191,192,193,194,195,196,197,198,199
	.byte	200,201,202,203,204,205,206,207,208,209
	.byte	210,211,212,213,214,215,216,217,218,219
	.byte	220,221,222,223,224,225,226,227,228,229
	.byte	230,231,232,233,234,235,236,237,238,239
	.byte	240,241,242,243,244,245,246,247,248,249
	.byte	250,251,252,253,254,255


	END
