      SUBROUTINE  GRWFLG
C     (Generate Read/Write With Flag(s))
C     PROCEDURE (Generate Read/Write With Flag(s))
C
C     The statement is
C
C     v---CCRW    v---CCLOGS(1)
C                      v---CCFLGS(1)
C                      xxxx----LFLGS(1)       v---CCLIST
C     ... (...... var1=key1,...,var2=key2,...) ...
C
C     where NFND pointers are set.   We copy the characters  CCRW
C     .. CCLOGS(1), then "key1", then insert "=nnnnn,".  Then  we
C     must copy characters CCFLGS(1)+LFLGS(1) ..  CCLOGS(2)-1, or
C     for the  last  keyword,  characters  CCFLGS(1)+LFLGS(1)  ..
C     CCLIST.
C
C     In the (parameter  list section), the  original version  of
C     this routine  discarded  all  but the  END=  and  ERR=  key
C     sections following  CCLOGS(1),  throwing  away  FORTRAN  77
C     keywords like "REC=nn".
C     (29-AUG-83)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       ADDBUF,      ATPENO,      IOFUNC,      NCODE
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                I,           K1,          K2
C
      INTEGER             I,           K1,          K2
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM02  /
C
      INTEGER             CCFLGS,      CCLIST,      CCNAME,      CCRW
      INTEGER             DEFNO,       INDEXS,      LFLGS,       LLIST
      INTEGER             LLOGS,       MAXLEV,      NEXT
C
      COMMON / COM02  /   CCFLGS(2),   CCLIST,      CCNAME,      CCRW
      COMMON / COM02  /   DEFNO,       INDEXS(38,39)
      COMMON / COM02  /   LFLGS(2),    LLIST,       LLOGS(2)
      COMMON / COM02  /   MAXLEV,      NEXT
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM03  /
C
      INTEGER             CASES,       CCINDX,      CCLOG,       CCLOGS
      INTEGER             LINDX,       LLOG
      INTEGER             MINDX,       NFND,        NONE
      INTEGER             NSTACK,      S1STAK,      SFNMBR
      LOGICAL             BLANK,       FOUND,       NOFLOW,      NONMBR
      LOGICAL             XLATED
C
      COMMON / COM03  /   BLANK,       CASES(39),   CCINDX,      CCLOG
      COMMON / COM03  /   CCLOGS(2),   FOUND,       LINDX
      COMMON / COM03  /   LLOG,        MINDX
      COMMON / COM03  /   NFND,        NOFLOW,      NONE,        NONMBR
      COMMON / COM03  /   NSTACK,      S1STAK(39),  SFNMBR
      COMMON / COM03  /   XLATED
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM05  /
C
      INTEGER             BLANKS,      LEFT,        LEVEL
      INTEGER             RIGHT,       S0,          S1,          STRCTS
      COMMON / COM05  /   BLANKS(92),  LEFT,        LEVEL
      COMMON / COM05  /   RIGHT,       S0,          S1
      COMMON / COM05  /   STRCTS(39)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM17  /
C
      INTEGER             ERROUT,      F4OUT,       INPUT,       SFOUT
C
      COMMON / COM17  /   ERROUT,      F4OUT,       INPUT,       SFOUT
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM30  /
C
      INTEGER             NB,          BUFFER
C
      COMMON / COM30  /   NB,          BUFFER(1326)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM31  /
C
      INTEGER             NS,          NSMAX,       STMT
C
      COMMON / COM31  /   NS,          NSMAX,       STMT(1326)
C
C
      CALL ADDBUF (BLANKS,1,6)
      CALL ADDBUF (STMT,CCRW,CCLOGS(1)-CCRW)
      I =1
      N20001=NFND
      GO TO 20002
20001 I =I +1
20002 IF ((N20001-I ).LT.0) GO TO 20003
      CALL ADDBUF (STMT,CCFLGS(I),LFLGS(I))
      CALL ADDBUF (6H=     ,1,6)
      CALL NCODE (BUFFER,NB - 4,NB,S0 + I)
      K1 = CCFLGS(I) + LFLGS(I)
      IF (.NOT.(I .LT. NFND)) GO TO 20005
      K2 = CCLOGS(I+1)
      GO TO 20006
20005 K2 = CCLIST
20006 CONTINUE
20007 IF (K1 .LT. K2) CALL ADDBUF (STMT,K1,K2-K1)
      GO TO 20001
20003 IF (LLIST .GT. 0) CALL ADDBUF (STMT,CCLIST,LLIST)
      ASSIGN 20008 TO NPR001
      GO TO 30001
20008 CALL IOFUNC (F4OUT,BUFFER,NB)
      NB = 0
C
      RETURN
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Attach Pending Number, if any, to Generated Statement)
30001 CALL ATPENO
      GO TO 20008
C
      END
